﻿using Upreader.Application.Default;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using Upreader.Application.Model;
using System.IO;
using Moq;
using System.Text;
using System.Resources;
using System.Reflection;

namespace Upreader.Application.Tests
{
    [TestClass]
    public class NzbParserTest
    {
        private Stream GetSampleNzbStream()
        {
            return GetType().Assembly.GetManifestResourceStream("Upreader.Application.Tests.SampleNzb.xml");
        }

        [TestMethod]
        public void SampleNzbCanBeParsed()
        {
            var contextMock = new Mock<IDomainContext>();
            contextMock.SetupGet(x => x.Downloads).Returns(new SimpleModelCollection<Download>());
            contextMock.SetupGet(x => x.Files).Returns(new SimpleModelCollection<Upreader.Application.Model.File>());
            contextMock.SetupGet(x => x.Segments).Returns(new SimpleModelCollection<Segment>());
            NzbParser target = new NzbParser(contextMock.Object);
            Stream stream = GetSampleNzbStream();
            target.Parse(stream, "test");            
        }
    }
}
