﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Upreader.Common.Cryptography;

namespace Upreader.Common.Tests
{
    [TestClass]
    public class FromCRC32TransformTest
    {
        [TestMethod]
        public void Hash_NoInput_IsEmpty()
        {
            // arrange
            FromCRC32Transform target = new FromCRC32Transform();
            byte[] expected = new byte[4];

            // act
            target.TransformFinalBlock(new byte[0], 0, 0);
            byte[] actual = target.Hash;

            // assert
            CollectionAssert.AreEqual(actual, expected);
        }

        [TestMethod]
        public void Hash_ByteInput_IsSuccesfull()
        {
            // arrange
            FromCRC32Transform target = new FromCRC32Transform();
            byte[] input = new byte[] { 1, 3, 3, 7 };
            byte[] expected = new byte[] { 46, 247, 192, 64 };

            // act
            target.TransformFinalBlock(input, 0, input.Length);
            byte[] actual = target.Hash;

            // assert
            CollectionAssert.AreEqual(actual, expected);
        }
    }
}
