﻿using Upreader.Usenet.Nntp.Encodings;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.IO;
using System.Linq;
using Moq;

namespace Upreader.Usenet.Nntp.Tests
{
    [TestClass]
    public class EncodedStreamTest
    {
        readonly byte[] packetText = Encoding.ASCII.GetBytes("test test test =test test test");

        internal virtual EncodedStream CreateEncodedStream()
        {
            var packetStream = new MemoryStream(packetText);

            var testDecoderStub = new Mock<IStreamDecoder>();
            var testDecoder = testDecoderStub.Object;

            EncodedStream target = new EncodedStream(new MemoryStream(packetText), new IStreamDecoder[] { testDecoder }, null);
            return target;
        }

        [TestMethod]
        public void Read_Valid_Succeeds()
        {
            EncodedStream target = CreateEncodedStream(); 
            int count = packetText.Length; 
            byte[] buffer = new byte[count]; 
            int offset = 0; 
            target.Read(buffer, offset, count);

            Assert.IsTrue(target.IsAvailableDecoderDetected);
            Assert.AreEqual(target.AvailableDecoder, target.StreamDecoders.First());
        }
    }
}
