﻿using Upreader.Usenet.Nntp;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Upreader.Usenet.Nntp.Tests
{
    [TestClass]
    public class ResponseMessageTest
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void Constructor_LineNull_Throws()
        {
            string line = null; 
            ResponseMessage target = new ResponseMessage(line);
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentException))]
        public void Constructor_LineToShort_Throws()
        {
            string line = "12";
            ResponseMessage target = new ResponseMessage(line);
        }

        [TestMethod]
        public void ParseResponseCode_Empty_Succeeds()
        {
            string line = "123 this is a test";
            ResponseMessage target = new ResponseMessage(line); 
            int expected = 123; 
            int actual;
            actual = target.ParseResponseCode();
            Assert.AreEqual(expected, actual);
        }
    }
}
