﻿using Upreader.Usenet.Nntp.Encodings;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Linq;
using System.Collections.Generic;

namespace Upreader.Common.Tests
{
    [TestClass]
    public class YencMetaLineTest
    {
        [TestMethod]
        public void Name_ValidLine_Succeeds()
        {
            string line = "begin size=100 test=test";
            YencMetaLine target = new YencMetaLine(line); 
            string expected = "begin";
            string actual = target.Name;

            Assert.AreEqual(expected, actual);
        }

        [TestMethod]
        public void Attributes_ValidLine_Succeeds()
        {
            string line = "begin size=100 test=test";
            YencMetaLine target = new YencMetaLine(line); 
            KeyValuePair<string, string>[] expected = new[]
                {
                    new KeyValuePair<string, string>("size", "100"),
                    new KeyValuePair<string, string>("test", "test")
                };

            IEnumerable<KeyValuePair<string, string>> actual = target.Attributes;

            CollectionAssert.AreEqual(expected.ToList(), actual.ToList());
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentNullException))]
        public void Constructor_LineNull_Throws()
        {
            string line = null; 
            YencMetaLine target = new YencMetaLine(line);
        }
    }
}
