﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Upreader.Application.Model
{
    /// <summary>
    /// Defines the state in which a segment can be
    /// </summary>
    public enum SegmentState
    {
        /// <summary>
        /// Indicates that the current segment has not been handled yet.
        /// </summary>
        Unhandled,
        /// <summary>
        /// Indicates that the current segment has been downloaded but is currently residing in cache
        /// </summary>
        Cached,
        /// <summary>
        /// Incidates that the current segment has been downloaded and assembled
        /// </summary>
        Assembled,
        /// <summary>
        /// Indicates that the current segment was assembled but it's output is broken
        /// </summary>
        AssembledBroken,
        /// <summary>
        /// Indicates that the segment was not found/available on the server
        /// </summary>
        Unavailable
    }
}
